

	;------------------------- MACRO ------------------------------------
	TEXT MACRO txt:VARARG
	LOCAL txtname
	.DATA
		txtname BYTE txt,0
		ALIGN 4
	.CODE 
	EXITM <ADDR txtname>
	ENDM
; -----------------------------------------------------------
  ; This macro replaces quoted text with a DATA section OFFSET
  ; and returns it in ADDR "name" format. It is used by other
  ; macros that handle optional quoted text as a parameter.
  ; -----------------------------------------------------------
    REPARG MACRO arg
      LOCAL nustr
        quot SUBSTR <arg>,1,1
      IFIDN quot,<">            ;; if 1st char = "
        .data
          nustr db arg,0        ;; write arg to .DATA section
        .code
        EXITM <ADDR nustr>      ;; append name to ADDR operator
      ELSE
        EXITM <arg>             ;; else return arg
      ENDIF
    ENDM	
  ; ------------------------------------------------
  ; Function return value version of the above macro
  ; ------------------------------------------------
    RV MACRO FuncName:REQ,args:VARARG
      arg equ <invoke FuncName>         ;; construct invoke and function name
      FOR var,<args>                    ;; loop through all arguments
        arg CATSTR arg,<,REPARG(var)>   ;; replace quotes and append arg
      ENDM
      arg                               ;; write the invoke macro
      EXITM <eax>                       ;; EAX as the return value
    ENDM


      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      PuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM

	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM

ZEROLOCALES MACRO dernierelocale:REQ
   mov edx,edi
   mov ecx,ebp
   lea edi,dernierelocale
   sub ecx,edi
   xor eax,eax
   shr ecx,2
   rep stosd
   mov edi,edx   
ENDM         	



